/**************************************************************************
**       Title: 
**    $RCSfile: CrossValidator.cc,v $
**   $Revision: 1.1 $$Name:  $
**       $Date: 2004/08/26 08:36:58 $
**   Copyright: GPL $Author: ronneber $
** Description:
**
**    
**
**-------------------------------------------------------------------------
**
**  $Log: CrossValidator.cc,v $
**  Revision 1.1  2004/08/26 08:36:58  ronneber
**  initital import
**
**
**
**************************************************************************/

#include <vector>
#include "CrossValidator.hh"

/*=========================================================================
 *  DESCRIPTION OF FUNCTION:  generateSortedSubsets
 *  ==> see headerfile
 *=======================================================================*/
void svt::generateSortedSubsets( int nFeatureVectors, int nSubsets,
                            std::vector<int>& subsetIndizesForFVs)
{
  float vectorsPerSubset = float(nFeatureVectors) / nSubsets;
  subsetIndizesForFVs.resize( nFeatureVectors);
  for( int i = 0; i < nFeatureVectors; ++i)
  {
    subsetIndizesForFVs[i] = int ( i / vectorsPerSubset);
  }
}


/*=========================================================================
 *  DESCRIPTION OF FUNCTION:  generateShuffledSubsets
 *  ==> see headerfile
 *=======================================================================*/
void svt::generateShuffledSubsets( int nFeatureVectors, int nSubsets,
                              std::vector<int>& subsetIndizesForFVs)
{
  generateSortedSubsets( nFeatureVectors, nSubsets, subsetIndizesForFVs);
  std::random_shuffle( subsetIndizesForFVs.begin(), subsetIndizesForFVs.end());
}


